pipeline {
    agent any
    parameters {
            string(
                name: "HOST_USER",
                defaultValue: "ubuntu"
            )
            string(
                name: "HOST_IP",
                defaultValue: "3.19.209.167"
            )
            string(
                name: "REGISTRY_URL",
                defaultValue: "registry-itau.mastertech.com.br/"
            )
            string(
                name: "MYIMAGE",
                defaultValue: "mateus_image_aws"
            )
    }
    stages {
        stage("Test") {
            steps{
                echo 'Starting unit tests'
                sh './mvnw test'
            }
        }
        stage("Build"){
            when{branch "master"}
            /*
            Todos os blocos de stage (Package, Build and push image e Deploy serão executados apenas
            quando o evento disparado pelo SCM for na branch master.
            */
            stages{
                stage("Package") {
                    when{branch "master"}
                    steps {
                        script{
                            sh "./mvnw package -DskipTests"
                        }
                    }
                }
                stage("Build and push image"){
                    steps{
                        script {
                            docker.withRegistry("https://${params.REGISTRY_URL}","registry_credential"){
                                def customImage=docker.build("${params.MYIMAGE}")
                                /* Os dois 'push' abaixo fazem o push da imagem para o registry com a tag latest e a tag do numero do build da pipeline */
                                customImage.push("${env.BUILD_ID}")
                                customImage.push("latest")
                            }
                        }
                    }
                }
                stage('Deploy'){
                    when{branch 'master'}
                        stages{
                            stage('Rollout Deployment'){
                                steps{
                                    sh "kubectl rollout restart deployment/mateus-deployment -n mateus-namespace"
                                    echo "Deployment realizado com sucesso!"
                                }
                            }
                        }
                    }
                }
            }
        }
    }